﻿using System;
using System.Linq;
using System.Web.UI.WebControls;
using Telerik.Web.UI;
using System.IO;
using Telerik.Web.UI.ImageEditor;

public partial class _Default : System.Web.UI.Page
{
	protected void Page_Load(object sender, EventArgs e)
	{
		TogglePanels();
	}

	protected void RadImageEditor1_ImageSaving(object sender, ImageEditorSavingEventArgs args)
	{
		using (MemoryStream ms = new MemoryStream())
		{
			args.Image.Image.Save(ms, args.Image.RawFormat);
			Context.Cache.Insert(Session.SessionID + "UploadedFile", ms, null, DateTime.Now.AddMinutes(20), TimeSpan.Zero);
		}

		var imageData = (MemoryStream)Context.Cache.Get(Session.SessionID + "UploadedFile");
		if (imageData != null)
			Thumbnail.DataValue = imageData.ToArray();

		args.Cancel = true;
	}

	protected void RadButton1_Click(object sender, EventArgs e)
	{
		TogglePanels(true);
		RadImageEditor1.SaveEditableImage("", true);
	}

	private void TogglePanels(bool hideEditImagePanel = false)
	{
		if (hideEditImagePanel)
		{
			EditImagePanel.Visible = false;
			ShowImagePanel.Visible = true;
			return;
		}

		var imageData = Context.Cache.Get(Session.SessionID + "UploadedFile");
		if (imageData != null)
		{
			EditImagePanel.Visible = true;
			ShowImagePanel.Visible = false;
		}
		else
		{
			EditImagePanel.Visible = false;
			ShowImagePanel.Visible = true;
		}
	}

	protected void AsyncUpload1_FileUploaded(object sender, FileUploadedEventArgs e)
	{
		//Clear changes and remove uploaded image from Cache
		RadImageEditor1.ResetChanges();
		Context.Cache.Remove(Session.SessionID + "UploadedFile");
		using (Stream stream = e.File.InputStream)
		{
			byte[] imgData = new byte[stream.Length];
			stream.Read(imgData, 0, imgData.Length);
			MemoryStream ms = new MemoryStream();
			ms.Write(imgData, 0, imgData.Length);

			Context.Cache.Insert(Session.SessionID + "UploadedFile", ms, null, DateTime.Now.AddMinutes(20), TimeSpan.Zero);
		}
		TogglePanels();
	}

	protected void RadImageEditor1_ImageLoading(object sender, ImageEditorLoadingEventArgs args)
	{
		//Handle Uploaded images
		if (!Object.Equals(Context.Cache.Get(Session.SessionID + "UploadedFile"), null))
		{
			using (EditableImage image = new EditableImage((MemoryStream)Context.Cache.Get(Session.SessionID + "UploadedFile")))
			{
				args.Image = image.Clone();
				args.Cancel = true;
			}
		}
	}
}